libstdc++: __gnu_debug::_Safe_forward_list< _SafeSequence > Class Template Reference

libstdc++

__gnu_debug::_Safe_forward_list< _SafeSequence > Class Template Reference

`#include <forward_list>`

Inheritance diagram for __gnu_debug::_Safe_forward_list< _SafeSequence >:
[legend]

## Public Member Functions
constexpr void | _M_invalidate_if (_Predicate __pred) const
void | _M_transfer_from_if (const _Safe_sequence &__from, _Predicate __pred) const

## Public Attributes
_Safe_iterator_base * | _M_const_iterators
_Safe_iterator_base * | _M_iterators
unsigned int | _M_version

## Protected Member Functions
void | _M_detach_all () const
void | _M_detach_singular () const
__gnu_cxx::__mutex & | _M_get_mutex () const noexcept
void | _M_invalidate_all () const
void | _M_revalidate_singular () const
void | _M_swap (const _Safe_forward_list &) const noexcept
void | _M_swap (const _Safe_sequence_base &__x) const noexcept

## Detailed Description

template<typename _SafeSequence>
class __gnu_debug::_Safe_forward_list< _SafeSequence >

Special iterators swap and invalidation for forward_list because of the before_begin iterator.

Definition at line 58 of file debug/forward_list.

## Member Function Documentation

## ◆ _M_detach_all()

void __gnu_debug::_Safe_sequence_base::_M_detach_all | ( |  | ) | const
| protectedinherited

Detach all iterators, leaving them singular.

## ◆ _M_detach_singular()

void __gnu_debug::_Safe_sequence_base::_M_detach_singular | ( |  | ) | const
| protectedinherited

Detach all singular iterators.

Postcondition
  for all iterators i attached to this sequence, i->_M_version == _M_version.

## ◆ _M_get_mutex()

__gnu_cxx::__mutex & __gnu_debug::_Safe_sequence_base::_M_get_mutex | ( |  | ) | const
| protectednoexceptinherited

For use in _Safe_sequence.

## ◆ _M_invalidate_all()

template<typename _SafeSequence>

void __gnu_debug::_Safe_forward_list< _SafeSequence >::_M_invalidate_all | ( |  | ) | const
| inlineprotected

Definition at line 75 of file debug/forward_list.

## ◆ _M_invalidate_if()

void __gnu_debug::_Safe_sequence< _SafeSequence >::_M_invalidate_if | ( | _Predicate | __pred | ) | const
| inlineconstexprinherited

Invalidates all iterators `x` that reference this sequence, are not singular, and for which `__pred(x)` returns `true`. `__pred` will be invoked with the normal iterators nested in the safe ones.

Definition at line 124 of file safe_sequence.h.

## ◆ _M_revalidate_singular()

void __gnu_debug::_Safe_sequence_base::_M_revalidate_singular | ( |  | ) | const
| protectedinherited

Revalidates all attached singular iterators. This method may be used to validate iterators that were invalidated before (but for some reason, such as an exception, need to become valid again).

## ◆ _M_swap() [1/2]

template<typename _SafeSequence>

void __gnu_debug::_Safe_forward_list< _SafeSequence >::_M_swap | ( | const _Safe_forward_list< _SafeSequence > & | __other | ) | const
| protectednoexcept

Definition at line 161 of file debug/forward_list.

## ◆ _M_swap() [2/2]

void __gnu_debug::_Safe_sequence_base::_M_swap | ( | const _Safe_sequence_base & | __x | ) | const
| protectednoexceptinherited

Swap this sequence with the given sequence. This operation also swaps ownership of the iterators, so that when the operation is complete all iterators that originally referenced one container now reference the other container.

## ◆ _M_transfer_from_if()

void __gnu_debug::_Safe_sequence< _SafeSequence >::_M_transfer_from_if | ( | const _Safe_sequence< _SafeSequence > & | __from,
|  | _Predicate | __pred ) const
| inherited

Transfers all iterators `x` that reference `from` sequence, are not singular, and for which `__pred(x)` returns `true`. `__pred` will be invoked with the normal iterators nested in the safe ones.

Definition at line 138 of file safe_sequence.tcc.

References _M_iterators.

## Member Data Documentation

## ◆ _M_const_iterators

_Safe_iterator_base* __gnu_debug::_Safe_sequence_base::_M_const_iterators
| mutableinherited

The list of constant iterators that reference this container.

Definition at line 227 of file safe_base.h.

## ◆ _M_iterators

_Safe_iterator_base* __gnu_debug::_Safe_sequence_base::_M_iterators
| mutableinherited

The list of mutable iterators that reference this container.

Definition at line 224 of file safe_base.h.

Referenced by _M_transfer_from_if().

## ◆ _M_version

unsigned int __gnu_debug::_Safe_sequence_base::_M_version
| mutableinherited

The container version number. This number may never be 0.

Definition at line 230 of file safe_base.h.

The documentation for this class was generated from the following file:

- debug/forward_list